/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * ArgDef.java
 *
 *
 */

package uiuc.Jumbo.Compiler;

import uiuc.Jumbo.Jaemus.Type;
import uiuc.Jumbo.Jaemus.Flags;

/**
 * A tuple class for formal arguments.
 * @version      1.0, 13 Nov 2001
 * @author       Lars Clausen
 *
*/

public class ArgDef {
    int flags;
    String name;
    Type type;
    public ArgDef(int flags, Type type, String name) {
        this.flags = flags;
        this.name = name;
        this.type = type;
    }
    public ArgDef(Type type, String name) {
        this.name = name;
        this.type = type;
    }
    public String toString() {
        return (flags!=0?Flags.toString(flags)+" ":"")+type+" "+name;
    }
}

/* End of class ArgDef*/
