/* Copyright (C) 2003, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * InnerInfo.java
 *
 *
 */

package uiuc.Jumbo.Compiler;

import uiuc.Jumbo.Jaemus.*;
import java.util.*;
import java.io.*;
import uiuc.Jumbo.Util.*;

/**
 * Stored information about inner classes.
 * @version      1.0, 6 Feb 2003
 * @author       Lars Clausen
 *
 */
public class InnerInfo {
    final Code cinner;
    final ClassInfo classinfo;
    final Local free;
    public InnerInfo(Code cinner, ClassInfo c, Local free) {
        this.cinner = cinner;
        this.classinfo = c;
        this.free = free;
    }
    public String toString() {
        if (free != null) 
            return classinfo.getName()+"["+free.size()+" free]";
        else
            return classinfo.getName()+"[no free]";
    }
}
