/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * AttributeInfo.java
 *
 *
 */

package uiuc.Jumbo.Jaemus;

import java.io.*;

/**
 * A superclass for all attributes
 * @version      1.0,  2 Oct 2001
 * @author       Lars Clausen
 *
*/

public abstract class AttributeInfo implements Emittable {
    public String name;
    public byte[] info;
    protected int size;
    private Constant nameconstant;
    
    public AttributeInfo(String name) {
        this.name = name;
    }

    public void prepareForEmit(ConstantPool c) {
        nameconstant = c.addUTF8(name);
    }

    public void emitHeader(DataOutputStream o) throws IOException {
        nameconstant.emitIndex(o);
        o.writeInt(size);
    }
    public void emitTo(DataOutputStream o) throws IOException {
        size = info.length;
        emitHeader(o);
        o.write(info);
    }
}

/* End of class AttributeInfo*/
