/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * Emittable.java
 *
 *
 */

package uiuc.Jumbo.Jaemus;

import java.io.*;

/**
 * An interface for bytecode parts that can actually be emitted
 * @version      1.0, 18 Oct 2001
 * @author       Lars Clausen
 *
*/

public interface Emittable {
    public void prepareForEmit(ConstantPool c);
    public void emitTo(DataOutputStream o) throws IOException;
}

/* End of class Emittable*/
