/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * AntiquoteIdentifierString.java
 *
 *
 */

package uiuc.Jumbo.Ast;

/**
 * A part of a dotted list identifier that is antiquoted
 * @version      1.0, 29 Oct 2002
 * @author       Lars Clausen
 *
*/

public class AntiquoteIdentifierString extends IdentifierString 
    implements Antiquote {
    public AntiquoteIdentifierString(Expression e) {
        super("ERROR"); // Should never be seen
        expression = e;
    }

    public IR toIR() {
        return IR.make(expression);
    }

    public String toUnquotedString() {
        throw new Error("Can't make source of antiquoted code "+expression);
    }

    public String toString() {
        return "`Name("+expression+")";
    }

    public boolean equals(Object o) {
        if (!(o instanceof AntiquoteIdentifierString)) return false;
        return expression.equals(((AntiquoteIdentifierString)o).expression);
    }

    Expression expression;
}

/* End of class AntiquoteIdentifierString*/
