/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * AntiquoteLiteral.java
 *
 *
 */

package uiuc.Jumbo.Ast;

import uiuc.Jumbo.Util.*;

/**
 * An antiquoted expression that is a (lifted) constant
 * @version      1.0, 30 Oct 2002
 * @author       Lars Clausen
 *
*/

public class AntiquoteLiteral extends Literal implements Antiquote
{
    public AntiquoteLiteral(Expression e) {
        /* Dummy call to superclass */
        super("", null);
        expression = e;
    }

    public IR toIR() {
        return IR.make("constant", new ArrayMonoList(IR.make(expression)));
    }

    public void toSource() {
        throw new Error("Antiquote at level 0");
    }
    
    public boolean equals(Object o) {
        if (o instanceof AntiquoteLiteral) {
            return expression.equals(((AntiquoteLiteral)o).expression);
        }
        return false;
    }

    protected Expression expression;
}

/* End of class AntiquoteLiteral*/
