/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package uiuc.Jumbo.Ast;

/**
 * Antiquoted expression meant to be used as a type.
 *
 * @author      Ava Arachne Jarvis
 * @version     %I%, %G%
 * @since       JDK 1.3
 */
public class AntiquoteType extends Type implements Antiquote
{
    public AntiquoteType(Expression e) {
        expression = e;
    }

    public IR toIR() {
        return IR.make(expression);
    }

    public Type copyType() {
        return new AntiquoteType(expression);
    }
    
    public void toSource() {
        throw new Error("Antiquote at level 0");
    }

    public String toString() {
        return "`Type("+expression+")";
    }

    public boolean isPrimitive() {
        return false;
    }
    
    protected Expression expression;
}

