/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package uiuc.Jumbo.Ast;
import uiuc.Jumbo.Util.*;

/**
 * Represents a boolean literal. 
 *
 * @author      Ava Arachne Jarvis
 * @version     %I%, %G%
 * @since       JDK 1.3
 */

public class BooleanLiteral extends Literal {
    /**
     * @param v   value of the literal
     */
    public BooleanLiteral( Boolean v ) { 
        super( "booleanConstant", v );
    }
    public BooleanLiteral( boolean v ) { 
        super( "booleanConstant", new Boolean(v) );
    }
    public void toSource() {
        print(value);
    }

    public IR toIR() {
        return IR.make("booleanConstant", new ArrayMonoList()
                        .add(IR.make(((Boolean)value).booleanValue())));
    }

    public boolean equals(Object o) {
        if (!(o instanceof BooleanLiteral)) return false;
        return value.equals(((BooleanLiteral)o).value);
    }
    
    public Type getType(ClassLoader loader) {
        return new Type("boolean");
    }
}
