/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * Represnts a break statement.
 *
 * @author      Ava Arachne Jarvis
 * @version     %I%, %G%
 * @since       JDK 1.3
 */
package uiuc.Jumbo.Ast;
import uiuc.Jumbo.Util.ArrayMonoList;

public class BreakStatement extends Statement {
    /**
     * @param l  optional label
     */
    public BreakStatement( String l ) { 
        label = l;
        constructor = "break";
    }

    /**
     * @param l  optional label
     */
    public BreakStatement( Identifier l ) { 
        this(l.toString());
    }

    public IR toIR() {
        if (label == null) {
            return IR.make(constructor+"Statement", new ArrayMonoList());
        }
        else {
            return IR.make(constructor+"StatementWithLabel", new ArrayMonoList()
                            .add(IR.make(label)));
        }
    }

    public void toSource() {
        if (label == null ) {
            print(constructor);
        } else {
            print(constructor+" "+label);
        }
    }

    public String toString() {
        if (label == null) return constructor;
        else return constructor+" "+label;
    }

    public String getLabel() {
        return label;
    }

    /**
     * Label of the break statement.
     */
    protected String label;
}
