/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package uiuc.Jumbo.Ast;
import uiuc.Jumbo.Util.*;

/**
 * Represents a Java package declaration.
 * 
 *
 * @author      Ava Arachne Jarvis
 * @version     %I%, %G%
 * @since       JDK 1.3
 */

public class PackageDeclaration extends Statement {
    /**
     * Creates a package declaration.
     *
     * @param pname  name of the package
     */
    public PackageDeclaration( Identifier pname ) { 
        package_name = pname;
    }

    public IR toIR() {
        return IR.make("definePackage", new ArrayMonoList()
                        .add(package_name.toIR()));
    }

    public void toSource() {
        print("package ");
        package_name.toSource();
    }


    /**
     * Name of the package.
     */
    protected Identifier package_name;
}
