/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package uiuc.Jumbo.Ast;

import java.util.*;
import java.util.Iterator;

import uiuc.Jumbo.Util.*;

/**
 * Represents a method invocation on super. 
 *
 * @author      Ava Arachne Jarvis
 * @version     %I%, %G%
 * @since       JDK 1.3
 */

public class SuperMethodInvocation extends MethodInvocation {
   /**
    * @param n     name of method being invoked
    * @param args  optional argument list
    */
   public SuperMethodInvocation( Identifier n, LinkedList args ) { 
      super("invokeSuper", null, n, args);
      default_string = "\"\"";
   }
    
    public void toSource() {
        print("super");
        if (name != null) {
            print(".");
            name.toSource();
        }
        printSourceArgumentList(arguments);
    }

    public IR toIR() {
        return IR.make("invokeSuper", new ArrayMonoList()
                       .add(IR.make(""))
                       .add(name.toIR())
                       .add(toIRList(arguments)));
    }
}
