/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * UnknownArrayCreation.java
 *
 *
 */

package uiuc.Jumbo.Ast;

import java.util.*;

/**
 * An array creation expression with an unknown type
 * @version      1.0, 25 Jul 2002
 * @author       Lars Clausen
 *
*/

public class UnknownArrayCreation extends ArrayCreation {
    public UnknownArrayCreation( String s, LinkedList d ) {
        super(null, d);
        setUnknownType(s);
    }
    protected boolean replaceUC(Object old_child, Object new_child) {
        if (old_child == type_string) {
            setUnknownType((String)new_child);
            return true;
        }
        else {
            return replaceInList(dimensions, (Node)old_child, (Node)new_child);
        }
    }
    private void setUnknownType( String s ) {
        type_string = s;
    }

    public void toSource() {
        print("new ");
        print("`Type("+type_string+")");
        print("[");
        printSourceList( dimensions, "][" );
        print("]");
    }


    /**
     * String representing a Type-type code value.
     */
    protected String type_string;
}

/* End of class UnknownArrayCreation*/
