/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package uiuc.Jumbo.Ast;

import java.util.*;

/**
 * Represents an unknown method declaration.
 *
 * @author      Ava Arachne Jarvis
 * @version     %I%, %G%
 * @since       JDK 1.3
 */

public class UnknownMethodDeclaration extends MethodDeclaration {
   /**
    * @param c   code of the method as a string
    */
   public UnknownMethodDeclaration( String c ) { 
      super(null, null);
      code = c;
   }

   /**
    * @param m list of modifiers
    */
   public void setModifiers( ModifierList m ) { }

   /**
    * @param t type of method
    */
   public void setType( Type t ) { }

   /**
    * @param thl throws list of the method
    */
   public void setThrowsList( LinkedList thl ) {}

   /**
    * @param b body of the method
    */
   public void setBody( StatementList s ) { }

    /**
     * The unknown piece of code.
     */
    protected String code;
}
