/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * See the file LICENSE for details.
 */
class Binary {
    private static void testIntOps( int a, int b ) { 
        System.out.print( a + b );
        System.out.print( " " );
        System.out.print( a - b ); 
        System.out.print( " " );
        System.out.print( a * b );
        System.out.print( " " );
        System.out.print( a / b );
        System.out.print( " " );
        System.out.print( a % b );
        System.out.print( " " );
        System.out.print( a & b );
        System.out.print( " " );
        System.out.print( a | b );
        System.out.print( " " );
        System.out.print( a ^ b );
        System.out.println();
    }

    private static void testFloatOps( float a, float b ) {
        System.out.print( a + b );
        System.out.print( " " );
        System.out.print( a - b ); 
        System.out.print( " " );
        System.out.print( a * b );
        System.out.print( " " );
        System.out.print( a / b );
        System.out.print( " " );
        System.out.print( a % b );
        System.out.println();
    }

    private static void testDoubleOps( double a, double b ) {
        System.out.print( a + b );
        System.out.print( " " );
        System.out.print( a - b ); 
        System.out.print( " " );
        System.out.print( a * b );
        System.out.print( " " );
        System.out.print( a / b );
        System.out.print( " " );
        System.out.print( a % b );
        System.out.println();
    }

    private static void testCastingOps( int a, double b ) {
        System.out.print( a + b );
        System.out.print( " " );
        System.out.print( a - b ); 
        System.out.print( " " );
        System.out.print( a * b );
        System.out.print( " " );
        System.out.print( a / b );
        System.out.print( " " );
        System.out.print( a % b );
        System.out.println();
    }

    public static void main(String argv[]) {
        testIntOps( 1, 2 );
        testIntOps( -10, 20 );
        testIntOps( -120, -237 );
        testIntOps( 12, -37 );

        testFloatOps( 0f, 3f );
        testFloatOps( -3f, -759.5345f );
        testFloatOps( 234.234f, -84.23410f );
        testFloatOps( 345915.421f, 2345015f );
        testFloatOps( 0.234324f, 0.234234f );

        testDoubleOps( 0.0, 3.0 );
        testDoubleOps( 1.0, 9.0 );
        testDoubleOps( -234.0113425, 234242.20980985 );
        testDoubleOps( -134315135.1353215151, 089531751.10375135 );
        testDoubleOps( 23049815.1304834, -13511.15135 );
        testDoubleOps( 0.23432432e43, 0.23523661616143e-57 );

        testCastingOps( 1, 1.0 );
        testCastingOps( 1, 3.0 );
        testCastingOps( -2352, 23432.23424 );
    }
}
