/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * See the file LICENSE for details.
 */
public class Exceptions {

    private static void except1() throws Exception {
        throw new Exception();
    }

    private static void except2() throws Exception {
        throw new Exception("An exception");
    }

    private static void except3( boolean throw_exception ) throws Exception {
        if ( throw_exception ) {
            throw new Exception( "Conditional Exception" );
        }
        else {
            System.out.println( "No exception thrown" );
        }
    }

    public static void main( String argv[] ) 
    {
        try {
            System.out.println( "Before except1" );
            except1();
            System.out.println( "Should not show up" );
        }
        catch ( Exception e ) {
            System.out.println( "Exception caught: " + e );
        }

        try {
            System.out.println( "Before except2" );
            except2();
            System.out.println( "Should not be reached" );
        }
        catch ( Exception e ) {
            System.out.println( "Exception caught: " + e );
        }

        try {
            System.out.println( "Before except3" );
            except3( false );
            System.out.println( "Should *be* reached" );
        }
        catch ( Exception e ) {
            System.out.println( "Exception shouldn't be caught!: " + e );
        }
        finally {
            System.out.println( "Reached finally." );
        }

        try {
            System.out.println( "Before except3" );
            except3( true );
            System.out.println( "Should NOT be reached!" );
        }
        catch ( Exception e ) {
            System.out.println( "Exception caught: " + e );
        }
        finally {
            System.out.println( "Should reach this finally finally." );
        }

    }
}
