/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This file is covered by the Illinois Open Source License, and may be
 * modified and redistributed with this copyright notice.
 * See the file LICENSE for details.
 */
import uiuc.Jumbo.Util.*;
import uiuc.Jumbo.Jaemus.*;
import uiuc.Jumbo.Compiler.*;

interface LoopIterator {
    Code iteration(Name n);
}

public class Hygiene {
    public static Code unroll(int n) {
        Name nm = new Name("x");
        return 
            $<for (int `nm = 0; `nm < `Int(n); `nm++) {
                `Stmt(new LoopIterator() {
                        Code iteration(Name n) {
                            return $<System.out.println(`n);>$;
                        }
                    }.iteration(nm)) } >$;
    }
    public static void main(String argv[]) {
        Code c = $<
            public class Hello {
                public static void main(String[] argv) { 
                    `Stmt(unroll(argv.length));
                }
            } >$;
        c.generate();
    }
}
