/* Copyright (C) 2002, University of Illinois.  All rights reserved. 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * LinkedMonoQueue.java
 *
 *
 */

package uiuc.Jumbo.Util;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Stack;

/**
 * A linked-list implementation of a MonoQueue.
 * @version      1.0,  7 Nov 2001
 * @author       Lars Clausen
 *
*/

public class LinkedMonoQueue implements MonoQueue {
    Object element;
    LinkedMonoQueue next;
    private Stack iteration_list;

    public LinkedMonoQueue() {
    }

    private LinkedMonoQueue(Object o, LinkedMonoQueue tail) {
        element = o;
        next = tail;
    }

    public MonoQueue add(Object o) {
        return new LinkedMonoQueue(o, this);
    }

    public Iterator iterator() {
        if (iteration_list == null) {
            Stack l = new Stack();
            for (LinkedMonoQueue q = this; q.element != null; q = q.next) {
                l.push(q.element);
            }
            iteration_list = l;
        }
        return iteration_list.iterator();
    }
}

/* End of class LinkedMonoQueue*/
